> For a complete page index, fetch https://developer.close.com/llms.txt # Export leads based on a search query POST https://api.close.com/api/v1/export/lead/ Content-Type: application/json You will receive a link to the generated file via email once the export is done. The exported file is GZIP compressed to make your download and our upload faster. The `content-encoding` HTTP header will be set to `gzip` and the `content-type` HTTP header will be set to `text/csv` for CSV exports or `application/json` for JSON exports. Parameters: - `s_query/results_limit/sort` (optional) - The [Advanced Filtering API](https://developer.close.com/api/resources/advanced-filtering) parameters used to narrow the exported results down. By default, all leads are exported. - `format` - Format of the exported file. The choices are: `csv`, `json`. JSON is recommended for raw backups or data migrations. - `type` - Type of the export. - `leads` - For CSV exports, it results in one row per lead. For JSON exports, this is the recommended type and is a superset of the other two types. - `contacts` - For CSV exports, it results in one row per contact. - `lead_opps` - For CSV exports, it results in one row per opportunity. - `date_format` (optional) - Controls the format of date objects. Note: this only works with the `csv` format. - `original` (default) - A date format that includes microseconds and timezone information. - Date: `[YYYY]-[MM]-[DD]` - Date w/ time: `[YYYY]-[MM]-[DD] [hh]:[mm]:[ss.sssss]±[hh]:[mm]` - `iso8601` (recommended) - An [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) compatible date representation that does not include microseconds. - Date: `[YYYY]-[MM]-[DD]` - Date w/ time: `[YYYY]-[MM]-[DD]T[hh]:[mm]:[ss]±[hh]:[mm]` - `excel` - An Excel compatible date format. Dates are always in UTC, do not include timezone information or microseconds, and use a 12 hour clock with an AM or PM designation. - Date: `[YYYY]-[MM]-[DD]` - Date w/ time: `[YYYY]-[MM]-[DD] [hh]:[mm]:[ss] [AM|PM]` - `fields` (optional) - By default we return all the data fields in each export type. If you only need specific fields exported, you can explicitly list them in `fields` to get smaller exports. - `include_activities` (optional) - Activities aren't included in any exports by default. If you want all your Activities exported as well, pass `"include_activities": true`. Note: this only works for `leads` type with `json` format. - `include_smart_fields` (optional) - Smart Fields aren't included in any exports by default. If you want all of them exported as well, pass `"include_smart_fields": true`. Note: this only works for `leads` type with `json` format or any type formatted as `csv`. Smart fields are calculated fields, like number of emails on a lead. - `send_done_email` - Set to `false` if you don't want to get a confirmation email after the bulk action is done. Reference: https://developer.close.com/api/resources/exports/create-lead ## Authentication - `Authorization` header (basic auth, required) — Use your API key as the username and leave the password empty. - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Body (application/json) This endpoint expects an any. - `any` ## Response ### 200 Successful response - `created_by` (string, required, nullable) - `date_created` (datetime, required) - `date_format` (enum, required) - Allowed values: `original`, `iso8601`, `excel` - `date_updated` (datetime, required) - `download_url` (string, required, nullable) - `fields` (list of string, required) - `format` (enum, required) - Allowed values: `csv`, `json` - `id` (string, required) - `n_docs` (integer, required, nullable) - `n_docs_processed` (integer, required) - `organization_id` (string, required) - `send_done_email` (boolean, required) - `status` (enum, required) - Allowed values: `created`, `started`, `in_progress`, `done`, `error` - `type` (enum, required) - Allowed values: `leads`, `contacts`, `lead_opps`, `opps`, `opportunities` - `updated_by` (string, required, nullable) - `limit` (integer, optional, nullable) - `params` (map from string to Json, optional, nullable) - `query` (string, optional, nullable) - `results_limit` (integer, optional, nullable) - `s_query` (map from string to Json, optional, nullable) - `sort` (list of map from string to Json, optional, nullable) ## Errors ### 400 Bad Request Error Bad request - `any` ### 401 Unauthorized Error Unauthorized - `any` ### 404 Not Found Error Not found - `any` ## Types ### Json ## Examples **Request** ```json { "date_format": "iso8601", "format": "csv", "results_limit": null, "s_query": { "queries": [ { "object_type": "lead", "type": "object_type" }, { "condition": { "mode": "full_words", "type": "text", "value": "ACME Inc." }, "field": { "field_name": "name", "object_type": "lead", "type": "regular_field" }, "type": "field_condition" } ], "type": "and" }, "send_done_email": false, "sort": [ { "direction": "desc", "field": { "field_name": "date_created", "object_type": "lead", "type": "regular_field" } } ], "type": "leads" } ``` **Response** ```json { "created_by": "user_N6KhMpzHRCYQHdn4gRNIFNN5JExnsrprKA6ekxM63XA", "date_created": "2014-04-02T15:00:05.190000+00:00", "date_format": "iso8601", "date_updated": "2014-04-02T23:36:30.719000+00:00", "download_url": null, "fields": [ "addresses", "contacts", "created_by", "created_by_name", "custom", "date_created", "date_updated", "description", "display_name", "id", "name", "status_id", "status_label", "updated_by", "updated_by_name", "url" ], "format": "csv", "id": "expo_yasdalskdjjflkahxrvLG8iVupzjoJVRPgrGhJ0A0b3bae", "n_docs": null, "n_docs_processed": 0, "organization_id": "orga_alksdjdfjasdfkljasdlkfjfaklsdjf", "send_done_email": false, "status": "created", "type": "leads", "updated_by": "user_N6KhMpzHRCYQHdn4gRNIFNN5JExnsrprKA6ekxM63XA", "results_limit": null, "s_query": { "queries": [ { "object_type": "lead", "type": "object_type" }, { "condition": { "mode": "full_words", "type": "text", "value": "ACME Inc." }, "field": { "field_name": "name", "object_type": "lead", "type": "regular_field" }, "type": "field_condition" } ], "type": "and" }, "sort": [ { "direction": "desc", "field": { "field_name": "date_created", "object_type": "lead", "type": "regular_field" } } ] } ``` **SDK Code** ```python import requests url = "https://api.close.com/api/v1/export/lead/" payload = { "date_format": "iso8601", "format": "csv", "results_limit": None, "s_query": { "queries": [ { "object_type": "lead", "type": "object_type" }, { "condition": { "mode": "full_words", "type": "text", "value": "ACME Inc." }, "field": { "field_name": "name", "object_type": "lead", "type": "regular_field" }, "type": "field_condition" } ], "type": "and" }, "send_done_email": False, "sort": [ { "direction": "desc", "field": { "field_name": "date_created", "object_type": "lead", "type": "regular_field" } } ], "type": "leads" } headers = { "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers, auth=("", "")) print(response.json()) ``` ```javascript const url = 'https://api.close.com/api/v1/export/lead/'; const credentials = btoa(":"); const options = { method: 'POST', headers: {Authorization: `Basic ${credentials}`, 'Content-Type': 'application/json'}, body: '{"date_format":"iso8601","format":"csv","results_limit":null,"s_query":{"queries":[{"object_type":"lead","type":"object_type"},{"condition":{"mode":"full_words","type":"text","value":"ACME Inc."},"field":{"field_name":"name","object_type":"lead","type":"regular_field"},"type":"field_condition"}],"type":"and"},"send_done_email":false,"sort":[{"direction":"desc","field":{"field_name":"date_created","object_type":"lead","type":"regular_field"}}],"type":"leads"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.close.com/api/v1/export/lead/" payload := strings.NewReader("{\n \"date_format\": \"iso8601\",\n \"format\": \"csv\",\n \"results_limit\": null,\n \"s_query\": {\n \"queries\": [\n {\n \"object_type\": \"lead\",\n \"type\": \"object_type\"\n },\n {\n \"condition\": {\n \"mode\": \"full_words\",\n \"type\": \"text\",\n \"value\": \"ACME Inc.\"\n },\n \"field\": {\n \"field_name\": \"name\",\n \"object_type\": \"lead\",\n \"type\": \"regular_field\"\n },\n \"type\": \"field_condition\"\n }\n ],\n \"type\": \"and\"\n },\n \"send_done_email\": false,\n \"sort\": [\n {\n \"direction\": \"desc\",\n \"field\": {\n \"field_name\": \"date_created\",\n \"object_type\": \"lead\",\n \"type\": \"regular_field\"\n }\n }\n ],\n \"type\": \"leads\"\n}") req, _ := http.NewRequest("POST", url, payload) req.SetBasicAuth("", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.close.com/api/v1/export/lead/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request.basic_auth("", "") request["Content-Type"] = 'application/json' request.body = "{\n \"date_format\": \"iso8601\",\n \"format\": \"csv\",\n \"results_limit\": null,\n \"s_query\": {\n \"queries\": [\n {\n \"object_type\": \"lead\",\n \"type\": \"object_type\"\n },\n {\n \"condition\": {\n \"mode\": \"full_words\",\n \"type\": \"text\",\n \"value\": \"ACME Inc.\"\n },\n \"field\": {\n \"field_name\": \"name\",\n \"object_type\": \"lead\",\n \"type\": \"regular_field\"\n },\n \"type\": \"field_condition\"\n }\n ],\n \"type\": \"and\"\n },\n \"send_done_email\": false,\n \"sort\": [\n {\n \"direction\": \"desc\",\n \"field\": {\n \"field_name\": \"date_created\",\n \"object_type\": \"lead\",\n \"type\": \"regular_field\"\n }\n }\n ],\n \"type\": \"leads\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.close.com/api/v1/export/lead/") .basicAuth("", "") .header("Content-Type", "application/json") .body("{\n \"date_format\": \"iso8601\",\n \"format\": \"csv\",\n \"results_limit\": null,\n \"s_query\": {\n \"queries\": [\n {\n \"object_type\": \"lead\",\n \"type\": \"object_type\"\n },\n {\n \"condition\": {\n \"mode\": \"full_words\",\n \"type\": \"text\",\n \"value\": \"ACME Inc.\"\n },\n \"field\": {\n \"field_name\": \"name\",\n \"object_type\": \"lead\",\n \"type\": \"regular_field\"\n },\n \"type\": \"field_condition\"\n }\n ],\n \"type\": \"and\"\n },\n \"send_done_email\": false,\n \"sort\": [\n {\n \"direction\": \"desc\",\n \"field\": {\n \"field_name\": \"date_created\",\n \"object_type\": \"lead\",\n \"type\": \"regular_field\"\n }\n }\n ],\n \"type\": \"leads\"\n}") .asString(); ``` ```php request('POST', 'https://api.close.com/api/v1/export/lead/', [ 'body' => '{ "date_format": "iso8601", "format": "csv", "results_limit": null, "s_query": { "queries": [ { "object_type": "lead", "type": "object_type" }, { "condition": { "mode": "full_words", "type": "text", "value": "ACME Inc." }, "field": { "field_name": "name", "object_type": "lead", "type": "regular_field" }, "type": "field_condition" } ], "type": "and" }, "send_done_email": false, "sort": [ { "direction": "desc", "field": { "field_name": "date_created", "object_type": "lead", "type": "regular_field" } } ], "type": "leads" }', 'headers' => [ 'Content-Type' => 'application/json', ], 'auth' => ['', ''], ]); echo $response->getBody(); ``` ```csharp using RestSharp; using RestSharp.Authenticators; var client = new RestClient("https://api.close.com/api/v1/export/lead/"); client.Authenticator = new HttpBasicAuthenticator("", ""); var request = new RestRequest(Method.POST); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"date_format\": \"iso8601\",\n \"format\": \"csv\",\n \"results_limit\": null,\n \"s_query\": {\n \"queries\": [\n {\n \"object_type\": \"lead\",\n \"type\": \"object_type\"\n },\n {\n \"condition\": {\n \"mode\": \"full_words\",\n \"type\": \"text\",\n \"value\": \"ACME Inc.\"\n },\n \"field\": {\n \"field_name\": \"name\",\n \"object_type\": \"lead\",\n \"type\": \"regular_field\"\n },\n \"type\": \"field_condition\"\n }\n ],\n \"type\": \"and\"\n },\n \"send_done_email\": false,\n \"sort\": [\n {\n \"direction\": \"desc\",\n \"field\": {\n \"field_name\": \"date_created\",\n \"object_type\": \"lead\",\n \"type\": \"regular_field\"\n }\n }\n ],\n \"type\": \"leads\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ```